
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Glossary_termsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const glossary_terms = await db.glossary_terms.create(
            {
                id: data.id || undefined,
        
        term: data.term
        ||
        null
            ,
            
        definition: data.definition
        ||
        null
            ,
            
        source_notes: data.source_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return glossary_terms;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const glossary_termsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                term: item.term
            ||
            null
            ,
            
                definition: item.definition
            ||
            null
            ,
            
                source_notes: item.source_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const glossary_terms = await db.glossary_terms.bulkCreate(glossary_termsData, { transaction });

        // For each item created, replace relation files
        

        return glossary_terms;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const glossary_terms = await db.glossary_terms.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.term !== undefined) updatePayload.term = data.term;
        
        
        if (data.definition !== undefined) updatePayload.definition = data.definition;
        
        
        if (data.source_notes !== undefined) updatePayload.source_notes = data.source_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await glossary_terms.update(updatePayload, {transaction});

        
        

        
        

        

        return glossary_terms;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const glossary_terms = await db.glossary_terms.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of glossary_terms) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of glossary_terms) {
                await record.destroy({transaction});
            }
        });


        return glossary_terms;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const glossary_terms = await db.glossary_terms.findByPk(id, options);

        await glossary_terms.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await glossary_terms.destroy({
            transaction
        });

        return glossary_terms;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const glossary_terms = await db.glossary_terms.findOne(
            { where },
            { transaction },
        );

        if (!glossary_terms) {
            return glossary_terms;
        }

        const output = glossary_terms.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.term) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'glossary_terms',
                        'term',
                        filter.term,
                    ),
                };
            }
            
            if (filter.definition) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'glossary_terms',
                        'definition',
                        filter.definition,
                    ),
                };
            }
            
            if (filter.source_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'glossary_terms',
                        'source_notes',
                        filter.source_notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.glossary_terms.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'glossary_terms',
                        'term',
                        query,
                    ),
                ],
            };
        }

        const records = await db.glossary_terms.findAll({
            attributes: [ 'id', 'term' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['term', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.term,
        }));
    }

    
};

